\ProvidesPackage{wzl}[2019/01/29]

% Encoding

\RequirePackage[T1]{fontenc}
\RequirePackage[utf8]{inputenc}

% Language

\RequirePackage[ngerman]{babel}
\RequirePackage{lmodern}

% Geometry

\RequirePackage{geometry}
\geometry{
    paper=a4paper,
    left=25mm,
    right=25mm,
    top=25mm,
    bottom=20mm,
    headheight=127mm,
    footskip=127mm
}

% Font

\RequirePackage{helvet}
\renewcommand{\familydefault}{\sfdefault}
\RequirePackage{setspace}
\setstretch{1.3}
\RequirePackage[parfill]{parskip}

% Colors

\usepackage{color}

% Autoformatting

\RequirePackage[all]{nowidow}
\emergencystretch=2em
\interfootnotelinepenalty=10000

% Code listings

\usepackage[newfloat]{minted}
\renewcommand{\listingname}{Quellcode}
\renewcommand{\listlistingname}{Quellcodeverzeichnis}
\providecommand*{\listingautorefname}{\listingname}

% Bibliography

\RequirePackage[autostyle]{csquotes}
\RequirePackage[backend=biber,style=wzl,date=short,maxnames=9999,mincrossrefs=9999]{biblatex}
\defbibheading{bibliography}[\refname]{\chapter{#1}}

% Figures

\RequirePackage{graphicx}
\RequirePackage{wrapfig}
\RequirePackage{float}

% Blockquotes

\RequirePackage{quoting}
\renewcommand*{\quotingfont}{\singlespace}

% Footnotes

\RequirePackage[hang]{footmisc}
\setlength{\footnotemargin}{4mm}
\RequirePackage{chngcntr}
\counterwithout{footnote}{chapter}

% Captions

\RequirePackage{caption}
\captionsetup{
    justification=raggedright,
    singlelinecheck=false,
    font={small,bf}
}

% Referencing

\RequirePackage{url}
\RequirePackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=black,
    citecolor=black,
    urlcolor=black,
    hypertexnames=false
}
\urlstyle{same}

% Segments

% Define frontmatter segment
\newcommand{\frontmatter}{
    \clearpage
    \pagestyle{meta}
    \setcounter{page}{0}
    \pagenumbering{roman}
    \setcounter{chapter}{0}
    \renewcommand{\thechapter}{\Roman{chapter}}
}
% Define mainmatter segment
\newcommand{\mainmatter}{
    \clearpage
    \pagestyle{content}
    \setcounter{page}{0}
    \pagenumbering{arabic}
    \newcounter{metachapter}
    \setcounter{metachapter}{\value{chapter}}
    \setcounter{chapter}{0}
    \renewcommand{\thechapter}{\arabic{chapter}}
}
% Define backmatter segment
\newcommand{\backmatter}{
    \clearpage
    \pagestyle{meta}
    \setcounter{chapter}{\value{metachapter}}
    \renewcommand{\thechapter}{\Roman{chapter}}
}

% Titles

\RequirePackage[compact]{titlesec}

% Chapter title
\titleformat{\chapter}[hang]{\normalfont\LARGE\bfseries}{\thechapter}{0.4cm}{}
% 8 pt
\titlespacing*{\chapter}{0pt}{-30pt}{0pt}
% Section title
\titleformat{\section}[hang]{\normalfont\Large\bfseries}{\thesection}{0.4cm}{}
% 18pt / 8pt
\titlespacing*{\section}{0pt}{0pt}{0pt}
% Subsection title
\titleformat{\subsection}[hang]{\normalfont\large\bfseries}{\thesubsection}{0.4cm}{}
% 16pt / 6pt
\titlespacing*{\subsection}{0pt}{0pt}{0pt}

% Headers

\RequirePackage{etoolbox}
\RequirePackage{titleps}

% Patch chapter definition
\patchcmd{\chapter}{\thispagestyle{plain}}{}{}{}
% Add header line
\newpagestyle{meta}{
    \setheadrule{1pt}%
    \sethead[\textbf{\thepage}]%  even-left
            []% even-center
            [\textbf{\thechapter\space\chaptertitle}]% even-right
            {\textbf{\thechapter\space\chaptertitle}}% odd-left
            {}% odd-center
            {\textbf{\thepage}}%  odd-right
}
\newpagestyle{content}{
    \setheadrule{1pt}%
    \sethead[\textbf{\thepage}]%  even-left
            []% even-center
            [\textbf{\thesection\space\sectiontitle}]% even-right
            {\textbf{\thechapter\space\chaptertitle}}% odd-left
            {}% odd-center
            {\textbf{\thepage}}%  odd-right
}

% TOCs

\RequirePackage{tocbibind}
\RequirePackage[titles]{tocloft}

% Add TOCs into table of contents
\renewcommand\tableofcontents{
    \chapter{\contentsname}
      \@mkboth{\MakeUppercase\contentsname}
              {\MakeUppercase\contentsname}
    \@starttoc{toc}
}
\renewcommand\listoffigures{
    \chapter{\listfigurename}
      \@mkboth{\MakeUppercase\listfigurename}
              {\MakeUppercase\listfigurename}
    \@starttoc{lof}
}
\renewcommand\listoftables{
    \chapter{\listtablename}
      \@mkboth{\MakeUppercase\listtablename}
              {\MakeUppercase\listtablename}
    \@starttoc{lot}
}
% Table of contents
\renewcommand{\cftchapleader}{\cftdotfill{\cftdotsep}}
% List of figures
\setlength{\cftfigindent}{0pt}
\renewcommand{\cftfigpresnum}{\figurename\enspace}
\renewcommand{\cftfigaftersnum}{:\enspace}
\newlength{\figlen}
\settowidth{\figlen}{\bfseries\cftfigpresnum\cftfigaftersnum}
\addtolength{\cftfignumwidth}{\figlen}
% List of tables
\setlength{\cfttabindent}{0pt}
\renewcommand{\cfttabpresnum}{\tablename\enspace}
\renewcommand{\cfttabaftersnum}{:\enspace}
\newlength{\tablen}
\settowidth{\tablen}{\cfttabpresnum\cfttabaftersnum}
\addtolength{\cfttabnumwidth}{\tablen}
% List of listings
\let\l@listing\l@figure
\patchcmd{\l@listing}{\cftfigpresnum}{\cftlistingpresnum}{}{}
\newcommand\cftlistingpresnum{\listingname~}

% Lists

\RequirePackage{enumitem}
\setlist[itemize]{parsep=0pt}
\setlist[enumerate]{parsep=0pt}

% Glossaries

\RequirePackage{tabu}
\RequirePackage[xindy,symbols,acronym,nomain]{glossaries}

\newcommand\acrfullrev[2][]{\acrshort[#1]{#2} (\acrlong[#1]{#2})}
\newcommand\acrfullplrev[2][]{\acrshortpl[#1]{#2} (\acrlongpl[#1]{#2})}

\renewcommand{\glossarysection}[2][]{}

\glssetnoexpandfield{unit}
\glsaddkey{unit}{\glsentrytext{\glslabel}}{\glsentryunit}{\GLsentryunit}{\glsunit}{\Glsunit}{\GLSunit}

\newglossarystyle{symbols}{
    \renewenvironment{theglossary}
        {\begin{longtabu} to \textwidth {XXX[3]}}
        {\end{longtabu}}
    \renewcommand*{\glsgroupskip}{}
    \renewcommand*{\glossaryheader}{%
        \textbf{Formelzeichen} &%
        \textbf{Einheit} &%
        \textbf{Beschreibung} \\ \hline \endhead%
    }
    \renewcommand*{\glossentry}[2]{%
        \glstarget{##1}{\glossentryname{##1}} &%
        \glsunit{##1} &%
        \glossentrydesc{##1} \tabularnewline%
    }
}

\newglossarystyle{acronyms}{
    \renewenvironment{theglossary}
        {\begin{longtabu} to \textwidth {X[1]X[2]}}
        {\end{longtabu}}
    \renewcommand*{\glsgroupskip}{}
    \renewcommand*{\glossaryheader}{%
        \textbf{Abkürzung} &%
        \textbf{Beschreibung} \\ \hline \endhead%
    }
    \renewcommand*{\glossentry}[2]{%
        \glstarget{##1}{\glossentryname{##1}} &%
        \glossentrydesc{##1} \tabularnewline%
    }
}
\endinput
